<?php

namespace App\Traits;

use Illuminate\Support\Carbon;
use Illuminate\Support\Facades\Storage;

trait FileStorageTrait
{
    protected static $storagePath = 'travelport/api/';

    public static function setStoragePath(string $path): void
    {
        self::$storagePath = $path;
    }

    public static function storeInFile(string $fileType, string $fileName, string $content): void
    {
        $path = self::$storagePath;

        $fileName = $fileName . "_" . Carbon::now(0)->timestamp;

        if ($fileType === 'xml') {
//            $content = self::prettyPrintXml($content);
        } elseif ($fileType === 'json') {
            $content = self::prettyPrintJson($content);
        }

        Storage::put($path . $fileName . '.' . $fileType, $content);
    }

    protected static function prettyPrintJson(string $jsonContent): string
    {
        $decodedJson = json_decode($jsonContent, true);

        if (json_last_error() == JSON_ERROR_NONE) {
            $content = json_encode($decodedJson, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);
            return $content !== false ? $content : $jsonContent;
        }

        return $jsonContent;
    }
}
